UVA 10318 - Security Panel dfs 剪枝

UVA 10318 - Security Panel dfs 剪枝

ACM

题目地址:UVA
10318 - Security Panel

题意:

这题跟点灯的题目很像,点灯游戏选择一盏灯时会让它以及四周的灯改变状态。

但是我们有特殊的开开关技巧,它给出了改变状态的位置,而不是四周都改变。

问你从全部关着变成全部开着的最小开关步骤。

分析:

很明显,在一个位置上点两次或更多次是没有必要的,所以一个位置只有选择与不选择,用dfs即可,但如果暴力所有可能,复杂度是2^25,会超时,所以要剪枝。

由于影响范围是3*3的,所以开关是无法影响两行前的状态的,只要在要走向下一行前判断下就行了。

由于数据量很小,这个剪枝足够了。

代码:

/*
*  Author:      illuz <iilluzen[at]gmail.com>
*  File:        10318.cpp
*  Create Date: 2014-06-29 19:51:39
*  Descripton:
*/

#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;
const int dx[] = {-1,-1,-1, 0, 0, 0, 1, 1, 1};
const int dy[] = {-1, 0, 1,-1, 0, 1,-1, 0, 1};

const int N = 6;

int r, c, cas;
int change[3*3], lit[N][N], prs[N*N], ans[N*N], cnt;
char str[4];

bool check(int l1) {
	if (l1 >= 0) {
		for (int i = 0; i < c; i++) {
			if (!lit[l1][i]) {
				return false;
			}
		}
	}
	return true;
}

void pressfunc(int x, int y) {
	for (int i = 0; i < 9; i++) {
		if (change[i]) {
			int tx = x + dx[i], ty = y + dy[i];
			if (tx >= 0 && tx < r && ty >= 0 && ty < c) {
				lit[tx][ty] = !lit[tx][ty];
			}
		}
	}
}

void dfs(int x, int y, int press) {
	if (y == c) {
		if (x == r - 1) {
			// check if all light
			for (int i = 0; i < r; i++) {
				if (!check(i)) {
					return;
				}
			}

			// if all light, update the ans
			if (press < cnt) {
				cnt = press;
				for (int i = 0; i < press; i++) {
					ans[i] = prs[i];
				}
			}
			return;
		} else {
			if (!check(x - 2)) {	// if not all light in line x - 2
				return;
			}
			x++;
			y = 0;
		}
	}

	// not press
	dfs(x, y + 1, press);

	// press
	pressfunc(x, y);
	prs[press] = c * x + y + 1;
	dfs(x, y + 1, press + 1);
	pressfunc(x, y);	// roll back
}

int main() {
	while (~scanf("%d%d", &r, &c) && (r || c)) {
		// input
		for (int i = 0; i < 3; i++) {
			scanf("%s", str);
			for (int j = 0; j < 3; j++) {
				change[i*3+j] = str[j] == '*' ? 1 : 0;
			}
		}

		// init
		memset(lit, 0, sizeof(lit));
		cnt = r * c + 1;

		// solve
		printf("Case #%d\n", ++cas);
		dfs(0, 0, 0);
		if (cnt != r * c + 1) {
			for (int i = 0; i < cnt - 1; i++) {
				printf("%d ", ans[i]);
			}
			printf("%d\n", ans[cnt - 1]);
		} else {
			puts("Impossible.");
		}
	}
	return 0;
}

UVA 10318 - Security Panel dfs 剪枝,布布扣,bubuko.com

时间: 2024-10-24 02:58:42

UVA 10318 - Security Panel dfs 剪枝的相关文章

UVa 10318 Security Panel

题意:给你一个3*3的翻转模版,深色部分表示翻转,浅色部分不变.然后你可以在r*c的矩形里依照模版进行翻转,要求所有点亮所有块.输出最小的步骤. 思路:有一点比较好想.每个块至多被翻转一次,翻两次的效果是一样的.这样可以搜索,大约2^25,会超时.考虑剪枝.对于每次翻转,只会影响与它临近的几个块,也就是说如果在该块的往上数第2行之前有没亮的块,那么无论之后怎么样,最后一定不会全亮,因为后面的块根本不会影响到前面这些. 这里可以用二进制表示状态.代码写的比较糟乱. #include<cstdio>

uva10318 Security Panel (dfs+剪枝)

题意: 有一个r*c的矩阵上选择一些格子进行"点亮"操作,使得最终所有格子都是"亮"的状态.初始时矩阵上面的所有格子是暗的,从左上到右下,编号从1开始. 现在我们给出一个3*3的矩阵,作为按钮规则: 例如: **. .*. *.. 也就是你按任意按钮,都把这个按钮当作是这个3*3矩阵的中心,按照这个规则,也就是按一个按钮,则这个按钮周围的 * 的位置,按照该规则,状态发生改变(如果它已经没有上一行了则忽略) 给出r,c代表几行几列 然后给出一个固定的3*3的矩阵,表

UVa 208 消防车(dfs+剪枝)

https://uva.onlinejudge.org/index.php?option=com_onlinejudge&Itemid=8&page=show_problem&problem=144 题意:给出一个n个结点的无向图以及某个结点k,按照字典序从小到大顺序输出从1到结点k的所有路径. 思路:如果直接矩阵深搜的话是会超时的,所以我们可以从终点出发,将与终点相连的连通块保存起来,这样dfs深搜时可以剪枝掉一些到达不了的点.只要解决了这个,dfs就是小问题. 这道题还有点坑的

【UVA】10318-Security Panel(DFS 回溯)

比较纠结的一道题,改了好几次才对. 首先需要知道的就是每个点如果重复点2次是没有任何意义的,所以一个点只有选或者不选,那么时间复杂度最大为2^25 毫无疑问超过了允许的范围,那么考虑减枝. 由于是3 X 3 的改变范围,所以如果 当前走到了第三行,那么就没办法更改第一行的状态,如果走到了第四行就无法更改第一 二行的状态,所以如果这个时候第一 二行 还没改成亮的它永远也不可能亮了. 最后一个就是需要输出按开关的次数最小的方案,一开始没看见,WA了好几次.. 14171735 10318 Secur

uva 219 - Department of Redundancy Department(dfs+剪枝)

题目链接:uva 219 - Department of Redundancy Department 题目大意:给定一些关系,问哪一些关系是可以被替代的,如果可以被替代,给出替代的方案,一种即可. 解题思路:因为总共也就26个字母,所以用二进制数表示状态.剪枝,每次将所有可选关系均考虑进去都无法满足则是false. #include <cstdio> #include <cstring> #include <algorithm> using namespace std;

ZOJ 1008 Gnome Tetravex (DFS + 剪枝)

Gnome Tetravex 题目:http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemId=8 题意:有N*N个方格,每个方格分为上下左右四个部分,每个部分填数字.现在要求重排方块,使得每两个有边相连的方块对应的数字相同. 思路:就是一个简单的搜索,我想了个剪枝,将上下左右四个方向上每个数字对应的是哪几个方块记录下来,但是这个剪枝并没有起很大的作用,还是T了.后来才发现,如果有很多个方块是相同的,会重复搜索,所以需要将相同的方块一起处

UVa 572 Oil Deposits(DFS)

 Oil Deposits  The GeoSurvComp geologic survey company is responsible for detecting underground oil deposits. GeoSurvComp works with one large rectangular region of land at a time, and creates a grid that divides the land into numerous square plots.

Cubes(DFS+剪枝)

题意:给一个数N,求N最少由多少个数的立方构成,并输出这些数. 做法:DFS + 剪枝,剪枝的边界很很很重要! 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 #include <stdio.h> int cub[400]; int ans[300]; int tp[300]; int n; int sum = 0x3f3f3f3f; //个数 void dfs(int le

hdu 4109 dfs+剪枝优化

求最久时间即在无环有向图里求最远路径 dfs+剪枝优化 从0节点(自己增加的)出发,0到1~n个节点之间的距离为1,mt[i]表示从0点到第i个节点目前所得的最长路径 #include<iostream> #include<cstdio> #include<cstring> #include<string> #include<algorithm> #include<vector> using namespace std; const